// y3D Engine by yoyofr - Work Around by Orion_ [2004]
// this were modified to simplify the engine use.

#include "gp32_types.h"

#include "3dngine.h"
#include "cossintab.h"
#include "polyfiller.h"
#include "ms3dLoader.h"
#include "math.h"
#include "texture.h"

extern int __freq_divisor;

/****************/

volatile int frame3d;
int frameCpt,frameTime,framerate,oframe3d,diff_frame;
int ax=0,ay=0,az=0;
int32 pos_X=0,pos_Y=0,pos_Z=0;

int m_numVertices;
int m_numTriangles;
int m_numMeshes;
Vertex *m_pVertices;
Triangle *m_pTriangles;
Mesh *m_pMeshes;


uint32 *m_sortedTrianglesIndex;
int32 *m_sortedTrianglesZ;
int m_numTriangles2Draw;


uint32 *radixsortTab;
uint32 *radixsortPos[256];
uint32 radixsortDistrib[256];
uint32 *pradix;
int32 *fix_div;

uint16 *halfval,*minval;



void gp32_timer3d(void) 
{	
	frame3d++;
}


// Added !

void yoyo3D_Rotate(int rx,int ry,int rz)
{
  ax=(ax+rx)&1023;	// hard :]
  ay=(ay+ry)&1023;
  az=(az+rz)&1023;
}

void yoyo3D_Translate(int32 px,int32 py,int32 pz)
{
  pos_X+=(px*frameTime);	// hard too :]
  pos_Y+=(py*frameTime);
  pos_Z+=(pz*frameTime);
}

// ----- !


void yoyo3D_Render(uint8 *oldbuffer,uint8 *vbuffer,uint8 rendermode,uint8 blurmode)
{
//	char text[256];
//	int flip;
//	uint8 *oldbuffer,*vbuffer;
	int32 x,y,z,rx,ry,rz,px,py,pz,cx,cy,cz,t;
	int32 xp,yp;
	int i,j,k,tmp;

	int32 cosx,cosy,cosz,sinx,siny,sinz;

//	int keywaiter;

	int32 minZ,maxZ;

//	oldbuffer=gpDraw[flip].ptbuffer;
//	vbuffer=gpDraw[flip^1].ptbuffer;
//	for (;;)
//	{			
		//gm_memcpy(oldbuffer,vbuffer,320*240*2);

		switch(blurmode)
		{
			case DONOTHING:
			  // asm("nop"); ? ^_^
			break;

			case ERASE:
			  gm_memset((char*)vbuffer,0,320*240*2);
			break;

			case BLUR:
			  for (i=0;i<320*240;i++)
				((uint16*)vbuffer)[i]=minval[((uint16*)oldbuffer)[i]];
			break;
		}

		for (i=0;i<m_numVertices;i++)
		{
		    x=m_pVertices[i].m_location[0];
		    y=m_pVertices[i].m_location[1];
		    z=m_pVertices[i].m_location[2];

		    //Rotation
		    sinx = fix_sin[ax];
		    siny = fix_sin[ay];
		    sinz = fix_sin[az];
		    cosx = fix_cos[ax];
		    cosy = fix_cos[ay];
		    cosz = fix_cos[az];

		    cx=m_pMeshes[m_pVertices[i].mesh].m_center[0];
		    cy=m_pMeshes[m_pVertices[i].mesh].m_center[1];
		    cz=m_pMeshes[m_pVertices[i].mesh].m_center[2];

		    /* 1re translation pour amener le "centre"  l'origine */
		    px = x - cx;
		    py = y - cy;
		    pz = z - cz;

		    /* Rotation autour de l'axe x'Ox */
		//t = (py*cosx - pz*sinx)>>16;
		SADDMULT1616(t,py,cosx,-pz,sinx)
		//pz = (py*sinx + pz*cosx)>>16;
		SADDMULT1616(pz,py,sinx,pz,cosx)
		py = t;
		/* Rotation autour de l'axe y'Oy */
		//t = (px*cosy + pz*siny)>>16;
		SADDMULT1616(t,px,cosy,pz,siny)
		//pz = (pz*cosy - px*siny)>>16;
		SADDMULT1616(pz,pz,cosy,-px,siny)
		px = t;
		/* Rotation autour de l'axe z'Oz */
		//t = (px*cosz - py*sinz)>>16;
		SADDMULT1616(t,px,cosz,-py,sinz)
		//py = (px*sinz + py*cosz)>>16;
		SADDMULT1616(py,px,sinz,py,cosz)
		px = t;
		    
		    
		    
		    /* Translation pour ramener le centre  sa place */
		    /* + translation mouvement */
		    rx = px + cx - pos_X;
		    ry = py + cy - pos_Y;
		    rz = pz + cz - pos_Z;
		    
		    m_pVertices[i].m_transformed[0]=rx;
		    m_pVertices[i].m_transformed[1]=ry;
		    m_pVertices[i].m_transformed[2]=rz;
		    
		    if ((rz>ZclipMin)&&(rz<ZclipMax))
		    {			
				xp=rx*SCREEN_WIDTH_2/(rz) + SCREEN_CENTER_X;
				yp=-ry*SCREEN_HEIGHT_2/(rz) + SCREEN_CENTER_Y;
//				xp=((int64)rx*SCREEN_WIDTH_2*(int64)fix_div24[rz>>_fixpoint_shifter]>>(_fixpoint_shifter*2)) + SCREEN_CENTER_X;
//				yp=((int64)ry*SCREEN_HEIGHT_2*(int64)fix_div24[rz>>_fixpoint_shifter]>>(_fixpoint_shifter*2)) + SCREEN_CENTER_Y;
			
				m_pVertices[i].m_projected[0]=xp;
				m_pVertices[i].m_projected[1]=yp;			
		    }
		}
		
		
		for (i=0;i<m_numVertices;i++)
		{
			x=m_pVertices[i].m_normal[0];
			y=m_pVertices[i].m_normal[1];
			z=m_pVertices[i].m_normal[2];
			
			//Rotation
			sinx = fix_sin[ax];
	    	siny = fix_sin[ay];
	    	sinz = fix_sin[az];
	    	cosx = fix_cos[ax];
	    	cosy = fix_cos[ay];
	    	cosz = fix_cos[az];
			
		    /* 1re translation pour amener le "centre"  l'origine */
		    
	    	px = x ;
	    	py = y ;
	    	pz = z ;
	    	/* Rotation autour de l'axe x'Ox */
		//t = (py*cosx - pz*sinx)>>16;
		SADDMULT1616(t,py,cosx,-pz,sinx)
		//pz = (py*sinx + pz*cosx)>>16;
		SADDMULT1616(pz,py,sinx,pz,cosx)
		py = t;
		/* Rotation autour de l'axe y'Oy */
		//t = (px*cosy + pz*siny)>>16;
		SADDMULT1616(t,px,cosy,pz,siny)
		//pz = (pz*cosy - px*siny)>>16;
		SADDMULT1616(pz,pz,cosy,-px,siny)
		px = t;
		/* Rotation autour de l'axe z'Oz */
		//t = (px*cosz - py*sinz)>>16;
		SADDMULT1616(t,px,cosz,-py,sinz)
		//py = (px*sinz + py*cosz)>>16;
		SADDMULT1616(py,px,sinz,py,cosz)
		px = t;
	
    /* Translation pour ramener le centre  sa place */
			rx = px;
			ry = py;
	    	rz = pz;
									
			m_pVertices[i].m_transformednormal[0]=rx;
			m_pVertices[i].m_transformednormal[1]=ry;
			m_pVertices[i].m_transformednormal[2]=rz;
		}
		
		for (i=0;i<m_numTriangles;i++)
		{			
			x=m_pTriangles[i].m_Normals[0];//+m_pTriangles[i].m_vertexNormals[1][0]+m_pTriangles[i].m_vertexNormals[2][0];
			y=m_pTriangles[i].m_Normals[1];//+m_pTriangles[i].m_vertexNormals[1][1]+m_pTriangles[i].m_vertexNormals[2][1]);
			z=m_pTriangles[i].m_Normals[2];//+m_pTriangles[i].m_vertexNormals[1][2]+m_pTriangles[i].m_vertexNormals[2][2];
			
			//Rotation			
			sinx = fix_sin[ax];
	    	siny = fix_sin[ay];
	    	sinz = fix_sin[az];
	    	cosx = fix_cos[ax];
	    	cosy = fix_cos[ay];
	    	cosz = fix_cos[az];
	
	    	// 1re translation pour amener le "centre"  l'origine 
	    	px = x;
	    	py = y;
	    	pz = z;
	    	/* Rotation autour de l'axe x'Ox */
		//t = (py*cosx - pz*sinx)>>16;
		SADDMULT1616(t,py,cosx,-pz,sinx)
		//pz = (py*sinx + pz*cosx)>>16;
		SADDMULT1616(pz,py,sinx,pz,cosx)
		py = t;
		/* Rotation autour de l'axe y'Oy */
		//t = (px*cosy + pz*siny)>>16;
		SADDMULT1616(t,px,cosy,pz,siny)
		//pz = (pz*cosy - px*siny)>>16;
		SADDMULT1616(pz,pz,cosy,-px,siny)
		px = t;
		/* Rotation autour de l'axe z'Oz */
		//t = (px*cosz - py*sinz)>>16;
		SADDMULT1616(t,px,cosz,-py,sinz)
		//py = (px*sinz + py*cosz)>>16;
		SADDMULT1616(py,px,sinz,py,cosz)
		px = t;
   			// Translation pour ramener le centre  sa place
	    	rx = px;
	    	ry = py;
	    	rz = pz;
									
			m_pTriangles[i].m_NormalsTransformed[0]=rx;
			m_pTriangles[i].m_NormalsTransformed[1]=ry;
			m_pTriangles[i].m_NormalsTransformed[2]=rz;

		}

		m_numTriangles2Draw=0;				

		for (i=0;i<m_numTriangles;i++)
		{			
			//if (m_pTriangles[i].m_NormalsTransformed[2]<=-65536*0.1)
			{					
				minZ=m_pVertices[m_pTriangles[i].m_vertexIndices[0]].m_transformed[2];
				maxZ=m_pVertices[m_pTriangles[i].m_vertexIndices[0]].m_transformed[2];
				if (m_pVertices[m_pTriangles[i].m_vertexIndices[1]].m_transformed[2]<minZ) minZ=m_pVertices[m_pTriangles[i].m_vertexIndices[1]].m_transformed[2];
				if (m_pVertices[m_pTriangles[i].m_vertexIndices[2]].m_transformed[2]<minZ) minZ=m_pVertices[m_pTriangles[i].m_vertexIndices[2]].m_transformed[2];
				if (m_pVertices[m_pTriangles[i].m_vertexIndices[1]].m_transformed[2]>maxZ) maxZ=m_pVertices[m_pTriangles[i].m_vertexIndices[1]].m_transformed[2];
				if (m_pVertices[m_pTriangles[i].m_vertexIndices[2]].m_transformed[2]>maxZ) maxZ=m_pVertices[m_pTriangles[i].m_vertexIndices[2]].m_transformed[2];
				if ((minZ>ZclipMin)&&(maxZ<ZclipMax))
				{
					m_sortedTrianglesZ[m_numTriangles2Draw]=m_pTriangles[i].m_Z=(
						(m_pVertices[m_pTriangles[i].m_vertexIndices[0]].m_transformed[2])+
						(m_pVertices[m_pTriangles[i].m_vertexIndices[1]].m_transformed[2])+
						(m_pVertices[m_pTriangles[i].m_vertexIndices[2]].m_transformed[2])
						)>>16;
					m_sortedTrianglesIndex[m_numTriangles2Draw]=i;				
					m_numTriangles2Draw++;
				}
			}
		}
			
			
		/* remise a zero du tableau des repartitions*/
		gm_memset(radixsortDistrib,0,256*sizeof(uint32));
		/*calcul de la repartition*/
		for (i=0;i<m_numTriangles2Draw;i++)
			radixsortDistrib[(uint8)(m_sortedTrianglesZ[i])]++;		
			
		/*init des pointeurs en fonction de la repartition*/
		radixsortPos[0]=radixsortTab;
		for (i=1;i<256;i++) radixsortPos[i]=radixsortPos[i-1]+radixsortDistrib[i-1];
		
		/*remplissage du tableau*/
		for (i=0;i<m_numTriangles2Draw;i++)
		{
			*radixsortPos[(uint8)(m_sortedTrianglesZ[i])]=m_sortedTrianglesIndex[i];
			radixsortPos[(uint8)(m_sortedTrianglesZ[i])]++;
		}
		/*relecture du tableau*/		
		for (i=0;i<m_numTriangles2Draw;i++)
		{
			m_sortedTrianglesIndex[i]=radixsortTab[i];
			m_sortedTrianglesZ[i]=m_pTriangles[radixsortTab[i]].m_Z;
		}
		
		/* remise a zero du tableau des repartitions*/
		gm_memset(radixsortDistrib,0,256*sizeof(uint32));
		/*calcul de la repartition*/
		for (i=0;i<m_numTriangles2Draw;i++)		
			radixsortDistrib[(uint8)(m_sortedTrianglesZ[i]>>8)]++;
						
		/*init des pointeurs en fonction de la repartition*/
		radixsortPos[0]=radixsortTab;
		for (i=1;i<256;i++) radixsortPos[i]=radixsortPos[i-1]+radixsortDistrib[i-1];
		
		/*remplissage du tableau*/
		for (i=0;i<m_numTriangles2Draw;i++)
		{
			*radixsortPos[(uint8)(m_sortedTrianglesZ[i]>>8)]=m_sortedTrianglesIndex[i];
			radixsortPos[(uint8)(m_sortedTrianglesZ[i]>>8)]++;
		}
		/*relecture du tableau*/		
		for (i=0;i<m_numTriangles2Draw;i++)
		{
			m_sortedTrianglesIndex[i]=radixsortTab[i];
			m_sortedTrianglesZ[i]=m_pTriangles[radixsortTab[i]].m_Z;
		}

		
		switch (rendermode)
		{
			case 0:
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				drawTriangle(j,m_pTriangles[j].mesh&1,(uint16*)vbuffer);
			}
			break;
			case 1:
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				drawTriangleGouraud(j,m_pTriangles[j].mesh&1,(uint16*)vbuffer);
			}
			break;
			case 2:
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				if (m_pTriangles[j].mesh<=4)
					drawTriangleTexture(j,1,(uint16*)vbuffer,(uint16*)texture_env1);					
				else
					drawTriangleGouraud(j,m_pTriangles[j].mesh&1,(uint16*)vbuffer);
			}
			break;
			case 3:
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				k=m_pMeshes[m_pTriangles[j].mesh].m_materialIndex;
				if (k) drawTriangleDoubleTexture(j,(uint16*)vbuffer,(uint16*)texture1,(uint16*)texture_env1);
				else drawTriangleDoubleTexture(j,(uint16*)vbuffer,(uint16*)texture2,(uint16*)texture_env2);
				
			}
			break;
			case 4:
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				if (m_pTriangles[j].mesh<=4)
					drawTriangleCorTexture(j,1,(uint16*)vbuffer,(uint16*)texture_env1);
				else
					drawTriangleGouraud(j,m_pTriangles[j].mesh,(uint16*)vbuffer);
			}
			break;
			case 5:									
			for (i=m_numTriangles2Draw-1;i>=0;i--)
			{
				j=m_sortedTrianglesIndex[i];
				if (m_pTriangles[j].mesh<=4)
					drawTriangleCorTexture(j,1,(uint16*)vbuffer,(uint16*)texture_env1);
				else						
					drawTriangleCorTexture(j,0,(uint16*)vbuffer,(uint16*)texture1);
								
			}
			break;
		}
		/* Calcul du framerate*/
		frameCpt++;
		if (frame3d-frameTime>=50)
		{
			framerate=frameCpt*50/(frame3d-frameTime);
			frameTime=frame3d;
			frameCpt=0;
		}
		
		
		/**********************/
		/* Affichage du cadre avec les infos*/
/*						
		for (i=8*240;i<160*240;i+=240)
		{			
			for (j=25;j<87;j++)
				((uint16*)vbuffer)[i+239-j]=halfval[((uint16*)vbuffer)[i+239-j]];				
			((uint16*)vbuffer)[i+239-25]=0xFFFF;	
			((uint16*)vbuffer)[i+239-87]=0xFFFF;	
		}		
		for (j=25;j<87;j++)
		{
			((uint16*)vbuffer)[8*240+239-j]=0xFFFF;
			((uint16*)vbuffer)[159*240+239-j]=0xFFFF;
		}
*/
		/**********************/
		/* Recupere les touches appuyes*/
/*
		int keypressed=GpKeyGet();
		if (keypressed&GPC_VK_SELECT) exit_first=0;
		if (keypressed&&exit_first) break;
*/
		/**********************/		
		/* Mouvements */
/*
		switch (movemode)
		{
			case 0:	
				//ax=frame3d*1;
				ay=frame3d*8;
				//az=frame3d*1;
				//pos_Z=-30*65536+(fix_cos[(frame3d<<1)&1023]<<3);
				break;
			case 1:
				//frame3d=0;
				//ax=fix_sin[(frame3d*1)&1023]>>10;
				//ay=fix_sin[(frame3d*3)&1023]>>9;			
				//az=fix_sin[(frame3d*2)&1023]>>10;	
				//pos_Z=-20*65536+(fix_cos[(frame3d<<1)&1023]<<3);
				break;
			case 2:
				diff_frame=frame3d-oframe3d;
				oframe3d=frame3d;
				if (keypressed&GPC_VK_UP) 
				{
					if (keypressed&GPC_VK_FA) pos_Y-=0.5*65536;
					else
					if (keypressed&GPC_VK_FB) ay-=3;
					else pos_Z-=0.5*65536;
				}
				if (keypressed&GPC_VK_DOWN) 
				{
					if (keypressed&GPC_VK_FA) pos_Y+=0.5*65536;
					else
					if (keypressed&GPC_VK_FB) ay+=3;
					else pos_Z+=0.5*65536;
				}
				if (keypressed&GPC_VK_LEFT) 
				{
					if (keypressed&GPC_VK_FA) ax+=3;
					else
					if (keypressed&GPC_VK_FB) az-=3;
					else pos_X+=0.5*65536;
				}
				if (keypressed&GPC_VK_RIGHT) 
				{
					if (keypressed&GPC_VK_FA) ax-=3;
					else
					if (keypressed&GPC_VK_FB) az+=3;
					else pos_X-=0.5*65536;
				}
				break;
			case 3:	
*/
/*				ax=frame3d*3;			
				ay=frame3d*5;
				az=frame3d*3;*/
/*
				if ((frame3d>120)&&(frame3d<120+512))				
					pos_Z=15*65536-20*65536+(fix_cos[(frame3d-120)&1023]*20);
				if (frame3d>120+512) 
				{
					movemode=1;
					frame3d=0;
				}
				break;
		}
*/
		ax&=1023;
		ay&=1023;
		az&=1023;
		/*************************/
		/* gestion des entrees*/
/*
		if (keywaiter<frame3d)
		{

			if (keypressed&(GPC_VK_START)) break;
			if (keypressed&(GPC_VK_FR)) 
			{
				rendermode++;
					keywaiter=frame3d+20;
*/
				/*if (keypressed&(GPC_VK_LEFT)) 
				{
					rendermode++;
					keywaiter=frame3d+20;
				}
				if (keypressed&(GPC_VK_RIGHT)) 
				{
					rendermode--;
					keywaiter=frame3d+20;
				}*/
/*	
			}
			if (keypressed&(GPC_VK_FL)) 
			{
				keywaiter=frame3d+20;
				//blurmode^=1;
			}
			if (keypressed&(GPC_VK_SELECT)) 
			{
				keywaiter=frame3d+20;
				movemode++;
				if (movemode>2) movemode=0;
if(movemode==2)
{
				ax=ay=az=0;
				pos_X=0*65536;
				pos_Y=0*65536;
				pos_Z=-50*65536;
}
			}
			if (rendermode<0) rendermode=5;
			if (rendermode>5) rendermode=0;
			
			
		}
	}
*/	
	/* Attente du relachement de toutes les touches quand on quitte*/
//	while (GpKeyGet());
}


// ***************************
// ***************************

uint8 yoyo3D_Init(char *modelfile)
{	
	int i,r,v,b,k;

	frame3d=frameTime=0;
	frameCpt=0;
	framerate=0;

	//char *vbuffer=gpDraw[flip].ptbuffer;
	//GpSurfaceFlip(&gpDraw[flip]);
	
	if(LoadModel(modelfile,&m_numVertices,&m_numTriangles,&m_numMeshes,&m_pVertices,&m_pTriangles,&m_pMeshes))
	{
			return 1;
	}

	/* Init des var internes*/
	m_sortedTrianglesIndex = (uint32 *)gm_malloc(m_numTriangles*sizeof(uint32));
	m_sortedTrianglesZ = (int32 *)gm_malloc(m_numTriangles*sizeof(int32));
	radixsortTab=(uint32*)gm_malloc(m_numTriangles*sizeof(uint32));		
	fix_div=(int32*)gm_malloc(65536*sizeof(int32));	

	minval = (uint16*)gm_malloc(65536*sizeof(uint16));

	for (i=0;i<65536;i++)
	{
		r=(i>>11)*4/5;
		v=((i>>6)&31)*4/5;
		b=((i>>1)&31)*4/5;
		if (r<0) r=0;
		if (v<0) v=0;
		if (b<0) b=0;
		minval[i]=(r<<11)|(v<<6)|(b<<1)|1;

		fix_div[i]=65536/(i+1);
	}
	/************************/

	/* Lancement du timer pour synchro des frames*/
    	GpTimerOptSet(0, (50*__freq_divisor)>>8, 0, gp32_timer3d);  // FIX: doesn't work ok...
    	GpTimerSet(0);

	/* Init du polygoniseur*/
	poly_init(m_pVertices,m_pTriangles,fix_div);

	return 0;
}

// ***************************
// ***************************

void yoyo3D_Close(void)
{
	int i;

	/* Deinit du polygoniseur*/
	poly_deinit();

	/* Deinit du model*/
	for (i=0;i<m_numMeshes;i++)
	{
		gm_free(m_pMeshes[i].m_pTriangleIndices);
	}
	gm_free(m_pVertices);
	gm_free(m_pTriangles);
	gm_free(m_pMeshes);
	gm_free(radixsortTab);
	gm_free(m_sortedTrianglesIndex);
	gm_free(m_sortedTrianglesZ);

	gm_free(minval);
	gm_free(fix_div);

    	GpTimerKill(0);
}



