/*
** Name: GP32 Yeti3D Port
** Desc: Portable 3D Engine based on Yeti3D
** Auth of MyYeti workaround: Bourse Cedric <orion-@wanadoo.fr>
** Auth of the port : Gazin Matthieu <matthieu.gazin@laposte.net>
** Original Auth of the engine: Derek J. Evans <derek@theteahouse.com.au>
** Copyright (C) 2003 Derek J. Evans. All Rights Reserved.
**
** YY  YY EEEEEE TTTTTT IIIIII 33333  DDDDD
** YY  YY EE       TT     II       33 DD  DD
**  YYYY  EEEE     TT     II     333  DD  DD
**   YY   EE       TT     II       33 DD  DD
**   YY   EEEEEE   TT   IIIIII 33333  DDDDD
**
**             OOOOO    NN    NN
**            OO   OO   NNNN  NN
**            OO   OO   NN NN NN
**            OO   OO   NN  NNNN
**             OOOOO    NN    NN
**
**  GGGGGGGG     PPPPPPP    333333     222222222
** GGGGGGGGGG   PPPPPPPPP    333333   22222222222
** GG           PP     PP        33   22       22
** GG     GG    PPPPPPPPP     33333         2222
** GG    GGGG   PPPPPPPP      33333      222
** GG      GG   PP               33    222
** GGGGGGGGGG   PP           333333   22222222222
**  GGGGGGGG    PP          333333    22222222222
**
**
** ----------------------------------------------------
** V 0.0.3.8 --> V 0.0.4.2 Created MyYeti workaround by Orion_ [2004]
**       Added ASM GCC hack (not really needed but easier for compiling)
**       Changed The buffer rendering, now using the GP32 SDK. (easier)
**       Splitted the whole gpmain function under Simples Fonctions to use the engine easier.
**       Added cleaning cell draw buffer. (this code was commented :| )
**       Removed All unused file, and code.
**       Added Print16 debug function
**       Added ORF and File loading inside Init Function
**       Removed ORF for public release. (nah nah nah ... you won't be able to extract data from BombermanWorld's ORF :p )
**
** V 0.0.3.7 --> V 0.0.3.8 custom by progfr
**
**		 - mettre les commentaire en francais
**		 - revoire les fonctions principale
**
**		 - mettre la gestion des sons des objets par les fonctions gpcm et gpstream
**		 - augmenter les types de lumiere
**		 - faire une gestion de porte a la doom dans 1 temps
**
** V 0.0.3.0 to V 0.0.3.7
**       Added Converting to direct acces the video 				-->OK
**       Added CPU mode added for enable the cache					-->OK
**       Added GP32 ID check for private beta added					-->NO
**       Added Direct control input check added						-->OK
**       Added MD2 model render										-->NO
**       Change Redefine the RGB basic buffer format				-->OK
**       Added GP32 Profile code for Yeti							-->OK
**       Change Following Dereck for global code change (ex:YETIROM)-->OK
**       Added Entity can be draw by sprite or MD2 model now		-->OK, juste les sprites
**       Added ASM DIVISE and FIXDIVIDE function for ARM.			-->OK
**       Added a little ligne/console write for init engine stats	-->OK
**       Added convertion LUA for speed up the draw part			-->OK
**       Added ASM copy screen fonction								-->..???
**       Added cleanig cell draw buffer only if draw overdistance for don't loose time. -->..??
**       Added external map loader									-->OK
**       Added external raw texture loader							-->OK
**       Added external pallette loader								-->OK
**       Change Desactivated fire and entity						-->OK, voir games.c
**       Change Cleaned GP32 code and Yeti Code.					-->reste a faire
**       Change Lasy to comment yeti 3D modified file, it will be do later :p --> ..???
**       Change Bit change in classique C function (copy screen) for optimise a little -->..???
**       Change Code change +1/2 fps on large zone (test on wipeout level by orion) -->..???
**       Remove All asm part remove so i remove my ASM DIVISE and FIXDIVIDE too. -->OK
**       Added external loader sprite											 -->OK
**       ...... (more but don't remember all :p)
**
** V 0.0.2.9
**       Added Structure code added using reference file for direct acces hardware of the gp32
**
** V 0.0.2.8
**       Change Using Direct acces LCD
**
** V 0.0.1.1 to V 0.0.2.7
**       Added Using SDK no special optimisation for the GP32
**       Added Try to port the engine to the GP32.
**
*/

#include "MyYeti.h"

// GCC hack
#include "asm1.h"

//-------------------------------+
// Les includes le moteur Yeti 3d|
//-------------------------------+

#include "viewports.h"
#include "game.h"

//-------------------------+
// Les include pour la GP32|
//-------------------------+

#include "gfxlib.h"
#include "bioslib.h"
#include "gp32.h"

//----------------------------------------------------------------------------+
// Ici sont declar les structure pour le moteur yeti 3d ainsi que le viewport|
//----------------------------------------------------------------------------+

framebuffer_t framebuffer;
yeti_t yeti;
rom_map_t rommap;

YETI_ROM texture_t textures[YETI_TEXTURE_MAX];
palette_t palette;
YETI_ROM lua_t lua;

//-------------------------------+
// Info sur le portage de la GP32|
//-------------------------------+

#define MYYETI_STR_TITLE	      "!!! This use MyYeti WorkAround System by Orion_ [2004] !!!"

#define YETI_GP32_PORT_STR_TITLE      "Yeti3D Engine -> GP32 PORT"
#define YETI_GP32_PORT_VERSION        "0.0.4.2"
#define YETI_GP32_PORT_STR_AUTOR      "GAZIN Matthieu"
#define YETI_GP32_PORT_STR_CAPTION    (YETI_GP32_PORT_STR_TITLE " " YETI_GP32_PORT_STR_VERSION " - " YETI_GP32_PORT_STR_AUTOR)

//---------------------------------------+
// configuration personel du tickcountget|
//---------------------------------------+

#define __gp32__timermul__ 100
#define __gp32__timerdiv__ 236
long gp32_GpTickCountGet(void);

unsigned char *tempo_texture_cache;

//----------------+
// Parametre video|
//----------------+

#define BUFFERSIZE 320*240*2*3
static unsigned char fbuf[BUFFERSIZE+4096];
struct LCDinfo lcd;
unsigned char *buffer;
unsigned char *vrambuffer,*currentbuffer;
extern void EnableCache(void);
unsigned long *GP32_PAL=(unsigned long *)0x14A00400; //32 bits?
GPDRAWSURFACE gpDraw[2];
u8 nflip;

//-----------------+
// SystemInit !!!! |
//-----------------+

// it doesn't use the triple/double buffer system of MrSpiv(?) anymore.
// cos, when rendering only yeti, it work well, but when rendering more other things, it flash/flicker(?).

void MyYeti_SystemInit(char *path)	// Initialise pratiquement tout pour eviter les problemes
{				// donc faut utiliser le buffer d'affichage de yeti par la suite.
//	ARMDisableInterruptSpiv();
	setCPUSpeed (132000000, 0x3a011, 3);
/*
	buffer =  (unsigned char *)(((long)(fbuf+4095) & ~4095));
	setup16bppMode(&lcd,buffer,2); 		 // --> double buffer
	lcd.clkval = 8;
	lcd.posx = 0;
	lcd.posy = 0;
	lcd.x = 240;
	lcd.y = 320;
	lcd.offx = 0;
	lcd.offy = 0;
	setupLCDMode(&lcd,1);
*/

	GpGraphicModeSet(16, NULL);		// SDK still powa %)
	GpLcdSurfaceGet(&gpDraw[0], 0);		// mmh ?
  	GpLcdSurfaceGet(&gpDraw[1], 1);		// #dontslap#
  	GpSurfaceSet(&gpDraw[0]);
  	nflip=1;

//	initTripleBufferDMA(&lcd,DMA0_INT,NULL);
//	cache_invalidate_all();
//	mmuChange(buffer,buffer+BUFFERSIZE,CACHE_CNW);

//	vrambuffer = doubleBuffer(&lcd,0);
//	currentbuffer = vrambuffer;
//	vrambuffer = doubleBuffer(&lcd,0);

//	EnableCache();
	GpFatInit();
	GpRelativePathSet(path);
}



//------------------------+
// LoadMapAndTexture !!!! |
//------------------------+

//----------------------+
//Parametre RGB pour LUA|
//----------------------+

int	lua_rgb (int r, int g, int b)
{
	int	r1 = (MIN (r, 255) * 31) / 255;
	int	g1 = (MIN (g, 255) * 31) / 255;
	int	b1 = (MIN (b, 255) * 31) / 255;

//	return (r1 << 10) + (g1 << 5) + b1;
return ( ( ( r1 ) << 11 )  |  ( ( g1 ) << 6 )  |  ( ( b1 ) << 1 ) );
}

//--------------------------------------------+
//Fonction pour charger les fichier raw et pal|
//--------------------------------------------+

void MyYeti_LoadMapAndTexture(char *orfarchive,char *mapname,char *texturename,char *palname)
{
	u8 *data;
	u32 num_tex,a,i;

	yeti_init(&yeti, &framebuffer, &framebuffer, textures, palette, lua);

	data=ORF_LoadFileToMemory(orfarchive,mapname);
	gm_memcpy(&rommap,data,sizeof(rommap));
	gm_free(data);

	yeti_load_map(&yeti, &rommap);
	game_init(&yeti);

	data=ORF_LoadFileToMemory(orfarchive,palname);
	gm_memcpy(palette,data,768);
	gm_free(data);

	data=ORF_LoadFileToMemory(orfarchive,texturename);
	num_tex=ucfilelen/(64*64);
	gm_memcpy(textures,data,ucfilelen);
	gm_free(data);

	for(a=0;a<64;a++)
	{
	  for(i=0;i<256;i++)
	  {
	    lua[a][i]=lua_rgb(palette[i][0]*a/16,palette[i][1]*a/16,palette[i][2]*a/16);
	  }
	}
}


//--------------------+
// ProcessRender !!!! |
//--------------------+

u16 tempbuffer[240*320];
u8 BLURACTIV;

void MyYeti_GetCurrentScreen(void)
{
    currentbuffer=gpDraw[nflip].ptbuffer;
    vrambuffer=gpDraw[!nflip].ptbuffer;
}

void MyYeti_ProcessRender(void)
{
//  static unsigned long Time;
  unsigned short *p_buf;
  int x,y,y_sav;

// This part was needed for autoflip with MrSpiv Triple Buffering System
// and that was bad ... because we can't control the flip ! (or maybe I'm too bad to understand how it work ...)
//  if ((int)(Time - GpTickCountGet()) < 0)
//  {
//    Time = GpTickCountGet() + YETI_VIEWPORT_INTERVAL;

    MyYeti_GetCurrentScreen();

    if(BLURACTIV) p_buf = (u16*)tempbuffer; else p_buf = (u16*)currentbuffer;

// Yes !! This blit function IS fast ! I tested with some ASM optimised blit function but It is slower than this :|
// ARM C compiler RoXXXX ! ;)
    for ( y = 0; y < 240; y++)
    {
      y_sav= 239-y;
      for(x = 0; x<320; x++)
      {
        p_buf[(x*240)+y_sav] = framebuffer.pixels[y][x];
      }
    }

// These are Very Sloooooow !
    if(BLURACTIV==1) DoSoftBlur(tempbuffer,currentbuffer);
    if(BLURACTIV==2) DoHardBlur(tempbuffer,currentbuffer);

    game_loop(&yeti);	// Process Engine

    // Clear moving flag
    yeti.keyboard.l=yeti.keyboard.r=yeti.keyboard.left=yeti.keyboard.right=
    yeti.keyboard.up=yeti.keyboard.down=yeti.keyboard.b=0;
//  }
}

// ***************************************** MyYeti Specific

void MyYeti_Flip(void)
{
    GpSurfaceFlip(&gpDraw[nflip]);	// then, we have still the flip control, that's better !
    nflip^=1;
}



u8 mystrlen(char *str)
{
  u8 l=0;
  while(*str++) l++;
  return l;
}

void Print16(u16 x, u16 y, char *text, u16 color)
{
  u8  tp,sl,*fontpos;
  u16 *screen,xl,yl;
  screen=(u16*)currentbuffer+(x*240)+(240-8-y);
  sl=mystrlen(text);

  for(tp=0;tp<sl;tp++)
  {
    fontpos=font8x8+(text[tp]*8*8);
    for(xl=0;xl<8;xl++)
    {
      for(yl=0;yl<8;yl++)
      {
        if(*(fontpos++)) *(screen)=color;
        screen++;
      }
      screen+=(240-8);
    }
  }
}

// Effectue un mouvement
void MyYeti_Move(u8 mode)
{
  switch(mode)
  {
    case UP:
      yeti.keyboard.l=1;
    break;

    case DOWN:
      yeti.keyboard.r=1;
    break;

    case LEFT:
      yeti.keyboard.left=1;
    break;

    case RIGHT:
      yeti.keyboard.right=1;
    break;

    case FORWARD:
      yeti.keyboard.up=1;
    break;

    case BACKWARD:
      yeti.keyboard.down=1;
    break;

    case JUMP:
      yeti.keyboard.b=1;
    break;
  }
}

// *****************************************



