// MyYeti: Work Around to init and use Yeti easier for any type of use. (not only game)
//  by Orion_ [2004]

#ifndef __MyYeti_h__
#define __MyYeti_h__

#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpfont.h"
#include "gpstdio.h"
#include "gpmem.h"
#include "gpmm.h"

#include "font8x8.h"

#include "orfgp32.h"

#include "yeti.h"

extern u8 BLURACTIV;	// 0=normal 1=softblur 2=hardblur

#define LEFT		1
#define RIGHT		2
#define UP		3
#define DOWN		4
#define FORWARD		5
#define BACKWARD	6
#define JUMP		7
#define STOP		0

extern void DoHardBlur(unsigned short *src, unsigned char *dest);
extern void DoSoftBlur(unsigned short *src, unsigned char *dest);

// Debug :)
void Print16(u16 x, u16 y, char *text, u16 color);

// Init System and Video + Set the path for the folder containing data.
void MyYeti_SystemInit(char *path);

// Load 3D World + Texture (now not from an orfarchive :D )
void MyYeti_LoadMapAndTexture(char *orfarchive,char *mapname,char *texturename,char *palname);

// Render Yeti in the Current Screen
void MyYeti_ProcessRender(void);

// Get the currentscreen buffer
extern unsigned char *vrambuffer,*currentbuffer; 	// use these.
void MyYeti_GetCurrentScreen(void);

// Flip (really ? o_O)
void MyYeti_Flip(void);

// Move ...
void MyYeti_Move(u8 mode);


#endif
